#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    //ofSetOrientation(OF_ORIENTATION_90_RIGHT);//Set iOS to Orientation Landscape Right
    ofBackground(255,255,255);
    ofSetFrameRate(30);
    font.loadFont("AvenirLTStd-Medium.otf", 40);
    
    grabber.setDeviceID(1);
    
    grabber.initGrabber(ofGetWidth(),ofGetHeight(), OF_PIXELS_BGRA);
    //tex.allocate(grabber.getWidth(), grabber.getHeight(), GL_RGB);
    
    buttonX=60;
    buttonY=60;
    buttonSize=200;
    eyebuttonSize=200;
    mapbuttonSize=200;
    isPressed=false;
    view="camera";
    img.loadImage("eyebutton1.png");
    cameraicon.loadImage("camera1.png");
    mapicon.loadImage("mapicon.png");
    //worldmap.loadImage("worldmap.png");
    zoomout.loadImage("zoomout.png");
    zoomin.loadImage("zoomin.png");
    frame.loadImage("frame.png");
    
    
    
    
    paintings[0].loadImage("01flower.jpg");
    paintings[1].loadImage("02dance.jpg");
    paintings[2].loadImage("03egypt.jpg");
    paintings[3].loadImage("04asianwoman.jpg");
    paintings[4].loadImage("05party.jpg");
    paintings[5].loadImage("25cat2.jpg");
    paintings[6].loadImage("21japan.jpg");
    paintings[7].loadImage("08crazyguy.jpg");
    paintings[8].loadImage("09finland.jpg");
    paintings[9].loadImage("10chicken.jpg");
    paintings[10].loadImage("11lunch.jpg");
    paintings[11].loadImage("12man.jpg");
    paintings[12].loadImage("13dog.jpg");
    paintings[13].loadImage("14farmer.jpg");
    paintings[14].loadImage("15family.jpg");
    paintings[15].loadImage("16manetolympia.jpg");
    /*
     paintings[16].loadImage("17chagall.jpg");
     paintings[17].loadImage("18earrings.jpg");
     paintings[18].loadImage("19merchant.jpg");
     paintings[19].loadImage("20paul.jpg");
     paintings[20].loadImage("21japan.jpg");
     paintings[21].loadImage("22swan.jpg");
     paintings[22].loadImage("23frida.jpg");
     paintings[23].loadImage("24van.jpg");
     paintings[24].loadImage("25cat2.jpg");
     paintings[25].loadImage("26asia.jpg");
     */
    
    // textbox[0].loadImage("textbox00.png");
    
    wmaps[0].loadImage("map00.png");
    wmaps[1].loadImage("map01.png");
    wmaps[2].loadImage("map02.png");
    wmaps[3].loadImage("map03.png");
    wmaps[4].loadImage("map04.png");
    wmaps[5].loadImage("map05.png");
    wmaps[6].loadImage("map06.png");
    wmaps[7].loadImage("map07.png");
    wmaps[8].loadImage("map08.png");
    wmaps[9].loadImage("map09.png");
    wmaps[10].loadImage("map10.png");
    wmaps[11].loadImage("map11.png");
    wmaps[12].loadImage("map12.png");
    wmaps[13].loadImage("map13.png");
    wmaps[14].loadImage("map14.png");
    wmaps[15].loadImage("map15.png");
    /*wmaps[16].loadImage("map00.png");
     wmaps[17].loadImage("map00.png");
     wmaps[18].loadImage("map00.png");
     wmaps[19].loadImage("map00.png");
     wmaps[20].loadImage("map00.png");
     wmaps[21].loadImage("map00.png");
     */
    
    
    
    
    //posX[] posY[] array
    posX[0]=-500;
    posX[1]=-3700;
    posX[2]=-300;
    posX[3]=0;
    posX[4]=-2800;
    posX[5]=-200;
    posX[6]=-70;
    posX[7]=-300;
    posX[8]=-200;
    posX[9]=-1500;
    posX[10]=-1100;
    posX[11]=-200;
    posX[12]=-500;
    posX[13]=-1100;
    posX[14]=-1000;
    posX[15]=-2400;
    /*posX[16]=0;
     posX[17]=0;
     posX[18]=-300;
     posX[19]=-300;
     posX[20]=-300;
     posX[21]=-300;
     posX[22]=-300;
     posX[23]=-300;
     posX[24]=-300;
     posX[25]=-300;
     */
    
    
    posY[0]=0;
    posY[1]=0;
    posY[2]=0;
    posY[3]=0;
    posY[4]=-1300;
    posY[5]=-600;
    posY[6]=0;
    posY[7]=-800;
    posY[8]=-900;
    posY[9]=-300;
    posY[10]=-1500;
    posY[11]=-50;
    posY[12]=-150;
    posY[13]=-200;
    posY[14]=-300;
    posY[15]=0;
    /*posY[16]=0;
     posY[17]=0;
     posY[18]=-300;
     posY[19]=-300;
     posY[20]=-300;
     posY[21]=-300;
     posY[22]=-300;
     posY[23]=-300;
     posY[24]=-300;
     posY[25]=-300;
     */
    
    
    
    
    // touch code examples
    /* posX= posY=0;
     scale=0.5;
     width=img.width*scale;
     height=img.height*scale;
     imgPixels=img.getPixels();
     */
    
    //each painting's story
    stories[0]="Born in 1902, Denmark\nYou were a poor painter's wife.\nYou felt lonely since your husband wasn't doing\nhis best to you.";
    stories[1]="Born in 1909, France\nYou were a very lively dancer.\nEverybody liked you.";
    stories[2]="Born in 668 BC, Egypt\nYou were an Egyptian queen in the first Persian\nPeriod. You were poisned by your own sister.";
    stories[3]="Born in 1780, Korea\nYou were a famous Korean geisha. You were misled \nby your friend into a life of drinking and gambling.";
    stories[4]="Born in 1876, France\nYou were a girl with youth, glamour and pizzazz.\nEveryone loved you.";
    stories[5]="Born in 1521, China\nYou were a greedy street cat in a small town. \nPeople didn't really like you.";
    stories[6]="Born in 1794, Japan\nYou were a servant who had a lot of complaints to\nyour master. Your master gave you too much work.";
    stories[7]="Born in 1893, Sweden\nYou were a man having a strong anger about your\nlife. You were an alcoholic being overly pessimistic.";
    stories[8]="Born in 1899, Finland\nYou were a loyal and brave girl working for\nyour country. Your hearts glowed with genuine \npatriotism";
    stories[9]="Born in 1621, Brazil\nYou were a rooster rasing your children responsibly.\nYou brought up a big family in a small town";
    stories[10]="Born in 1862, France\nYou were a freewheeling woman who loved chatting\nwith friends. You loved to be naked and were\na heavy smoker.";
    stories[11]="Born in 1913, Austria\nYou were an artist who spent a lonely and friendless\nlife. You were regarded as a strange person. Shy and\nreserved.";
    stories[12]="Born in 1711, Greece\nYou were a lazy dog who didn't like being bothered.";
    stories[13]="Born in 1930, USA\nYou were a obstinate farmer and your daughter\ndidn't like you. You thought nobody understood you.";
    stories[14]="Born in 1905, Spain\nYou were a circus performer.\nYou often lost self-esteem and self-respect because of\npoverty.";
    stories[15]="Born in 1863, France\nYou were a slave serving your master's mistress. \nYou were depressed and very angry about your life.";
    /*stories[16]="1918, Belarus, You were a lucky man who lived a happy life with your wife.";
     stories[17]="1665, Holland, You were a shy girl interested in fashion.";
     stories[18]="1738, Holland, You were a soldier delighted to hear the termination of the war.";
     stories[19]="1892, Tahiti, You were a painter's wife.";
     stories[20]="1794, Japan, You were a servant who had a lot of complaints to your master.";
     stories[21]="1745, France, You were a valiant swan which didn't fear anything.";
     stories[22]="1940, Mexico, You were a black monkey worrying about your master.";
     stories[23]="1434, Italy, You were a very rich merchant married a beautiful young wife.";
     stories[24]="1434, You were a very rich Italian merchant";
     stories[25]="1770, Korea, You were a nobleman and had a lot of jealousy and possessiveness.";
     */
    
    
    
    //each painting's scale
    scale[0]=2; //13 is more focusing on the face
    scale[1]=3;
    scale[2]=3;
    scale[3]=5.5;
    scale[4]=7;
    scale[5]=2;
    scale[6]=0.7;
    scale[7]=2;
    scale[8]=2;
    scale[9]=3;
    scale[10]=1.7;
    scale[11]=0.9;
    scale[12]=2;
    scale[13]=2;
    scale[14]=4;
    scale[15]=2.5;
    ;//the quality is too low, have to change it
    // scale[3]=5.5;//perfect
    //scale[4]=2;//change the image, size is too small.
    //scale[5]=3;
    
    
    
    
    
    
    
    
}

//--------------------------------------------------------------
void ofApp::update(){
    
    
    if (view=="camera") {
        grabber.update();
    }
    
    //tex.loadData(pix, grabber.getWidth(), grabber.getHeight(), GL_RGB);
    
    
}

//--------------------------------------------------------------
void ofApp::draw(){
    
    
    
    if (view=="camera") {
        ofSetColor(255);
        
        grabber.draw(0,0,ofGetWidth(),ofGetHeight());
        frame.draw(0,0,ofGetWidth(), ofGetHeight());
        cameraicon.draw(ofGetWidth()-buttonSize*1.5, buttonSize*0.5, buttonSize,buttonSize);
        
        if (photoSavedToLibrary==true) {
            //take screen capture
            photoPixels=grabber.getPixels();
            photo.setFromPixels(photoPixels, grabber.width, grabber.height, OF_IMAGE_COLOR);
            view="screencapture";
        }
    } else if (view=="screencapture"){
        photo.draw(0,0,ofGetWidth(),ofGetHeight());
        img.draw(ofGetWidth()- eyebuttonSize*1.5, eyebuttonSize*0.5,eyebuttonSize,eyebuttonSize);
        //view="paintingnumbers";
    }else if (view=="Paintingnumbers"){
        
        //ofSetColor(255, 11, 11);
        //ofRect(0, 100, 100, 1001);
        //numbers= ofRandom(numberofpaintings);
        ofSetColor(255);
        /* // Load Random paintings
         paintings[Pnumbers].draw(0,0,paintings[Pnumbers].width*scale[Pnumbers],paintings[Pnumbers].height*scale[Pnumbers]);*/
        
        //Set up the scale AND posX,Y corresponding to each painting
        
        //paintings[1].draw(posX[1],posY[1],paintings[1].width*scale[1],paintings[1].height*scale[1]);
        
        //Test for multitouch example
        ofBackground(0);
        
        paintings[Pnumbers].draw(posX[Pnumbers],posY[Pnumbers],paintings[Pnumbers].width*scale[Pnumbers],paintings[Pnumbers].height*scale[Pnumbers]);
        //paintings[15].draw(posX[15],posY[15],paintings[15].width*scale[15],paintings[15].height*scale[15]);
        
        cameraicon.draw(ofGetWidth()-buttonSize*1.5,buttonSize*0.5, buttonSize,buttonSize);
        mapicon.draw(ofGetWidth()-buttonSize*1.5, buttonSize*1.5, buttonSize,buttonSize);
        zoomout.draw(ofGetWidth()-buttonSize*1.5, buttonSize*2.5, buttonSize,buttonSize);
        //font
        ofSetColor(0, 0, 0,70);
        ofRect(20, ofGetHeight()-320, ofGetWidth()-40, 300);
        ofSetColor(255);
        font.drawString(stories[Pnumbers],40,ofGetHeight()-260);
        
        
    } else if (view=="worldmap"){
        ofSetColor(255);
        wmaps[Pnumbers].draw(0,0,ofGetWidth(),ofGetHeight());
        cameraicon.draw(ofGetWidth()-buttonSize*1.5,buttonSize*0.5, buttonSize,buttonSize);
        img.draw(ofGetWidth()- eyebuttonSize*1.5, eyebuttonSize*1.5,eyebuttonSize,eyebuttonSize);
        //img.draw(ofGetWidth()- eyebuttonSize*1.5, eyebuttonSize*1.5,eyebuttonSize,eyebuttonSize);
        
    } else if (view=="zoomout"){
        ofSetColor(255);
        paintings[Pnumbers].draw(0,0,ofGetWidth(),paintings[Pnumbers].height*ofGetWidth()/paintings[Pnumbers].width);
        cameraicon.draw(ofGetWidth()-buttonSize*1.5,buttonSize*0.5, buttonSize,buttonSize);
        mapicon.draw(ofGetWidth()-buttonSize*1.5, buttonSize*1.5, buttonSize,buttonSize);
        zoomin.draw(ofGetWidth()-buttonSize*1.5, buttonSize*2.5, buttonSize,buttonSize);
        ofSetColor(0, 0, 0,70);
        ofRect(20, ofGetHeight()-320, ofGetWidth()-40, 300);
        ofSetColor(255);
        font.drawString(stories[Pnumbers],40,ofGetHeight()-260);
        
    }
    
    
}

//--------------------------------------------------------------
void ofApp::exit(){
    
}

//--------------------------------------------------------------
void ofApp::touchDown(ofTouchEventArgs & touch){
    
    if (view=="camera"){
        if(touch.id==0){
            float l=ofGetWidth()-buttonSize*1.5;
            float r=l+buttonSize;
            float t=buttonSize*0.5;
            float b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                photoSavedToLibrary=true;
            }
        }
    } else if(view=="zoomout"){
        if(touch.id==0){
            //camerabutton
            float l=ofGetWidth()-buttonSize*1.5;
            float r=l+buttonSize;
            float t=buttonSize*0.5;
            float b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                view="camera";
                photoSavedToLibrary=false;
                grabber.update();
                
            }
            
            //zoominbuton
            l=ofGetWidth()-buttonSize*1.5;
            r=l+buttonSize;
            t=buttonSize*2.5;
            b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                
                //zoom in position and scale
                view="Paintingnumbers";
            }
            
            //worldmap button
            l=ofGetWidth()-mapbuttonSize*1.5;
            r=l+mapbuttonSize;
            t=mapbuttonSize*1.5;
            b=t+mapbuttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                
                view="worldmap";
                return;
                //zoom out position and scale
            }
        }
    }else if (view=="Paintingnumbers") {
        if(touch.id==0){
            //camerabutton
            float l=ofGetWidth()-buttonSize*1.5;
            float r=l+buttonSize;
            float t=buttonSize*0.5;
            float b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                view="camera";
                photoSavedToLibrary=false;
                grabber.update();
                
            }
            
            //zoomout button
            l=ofGetWidth()-buttonSize*1.5;
            r=l+buttonSize;
            t=buttonSize*2.5;
            b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                
                //zoom out position and scale
                view="zoomout";
            }
            
            //worldmap button
            l=ofGetWidth()-mapbuttonSize*1.5;
            r=l+mapbuttonSize;
            t=mapbuttonSize*1.5;
            b=t+mapbuttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                
                view="worldmap";
                //zoom out position and scale
            }
        }
        
    }else if (view=="screencapture"){
        if(touch.id==0){
            float l1=ofGetWidth()-eyebuttonSize*1.5;
            float r1=l1+eyebuttonSize;
            float t1=eyebuttonSize*0.5;
            float b1=t1+eyebuttonSize;
            if (touch.x>l1 && touch.x<r1 && touch.y>t1 && touch.y<b1) {
                Pnumbers= ofRandom(numberofpaintings);
                printf("%i \n",Pnumbers);
                view="Paintingnumbers";
            }
        }
    }else if(view=="worldmap"){
        //camerabutton
        if(touch.id==0){
            float l=ofGetWidth()-buttonSize*1.5;
            float r=l+buttonSize;
            float t=buttonSize*0.5;
            float b=t+buttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                view="camera";
                photoSavedToLibrary=false;
                grabber.update();
                
            }
            //eyebutton
            l=ofGetWidth()-eyebuttonSize*1.5;
            r=l+eyebuttonSize;
            t=eyebuttonSize*1.5;
            b=t+eyebuttonSize;
            if (touch.x>l && touch.x<r && touch.y>t && touch.y<b) {
                
                view="Paintingnumbers";
               
            }

            
            
            //eyebutton
            
            /*float l1=ofGetWidth()-eyebuttonSize*1.5;
             float r1=l1+eyebuttonSize;
             float t1=eyebuttonSize*0.5;
             float b1=t1+eyebuttonSize;
             if (touch.x>l1 && touch.x<r1 && touch.y>t1 && touch.y<b1) {
             Pnumbers= ofRandom(numberofpaintings);
             printf("%i \n",Pnumbers);
             view="Paintingnumbers";
             }*/
            
            
            
        }
        
    }
    
}

//--------------------------------------------------------------
void ofApp::touchMoved(ofTouchEventArgs & touch){
    
    /* if (touch.id==0){
     
     float right=posX[Pnumbers]+paintings[Pnumbers].width*scale[Pnumbers];
     float bottom=posY[Pnumbers]+paintings[Pnumbers].height*scale[Pnumbers];
     
     if(touch.x>posX[Pnumbers] && touch.x<right && touch.y>posY[Pnumbers] && touch.y<bottom){
     
     posX[Pnumbers]=touch.x-distX;
     posY[Pnumbers]=touch.y-distY;
     
     }
     }*/
    
    /*if(touch.id==1){
     //scale the image
     scale[Pnumbers]=ofDist(touch.x,touch.y,posX[Pnumbers], posY[Pnumbers]);
     // width=paintings[Pnumbers].width*scale[Pnumbers];
     //height=paintings[Pnumbers].height*scale[Pnumbers];
     //printf(
     // "scale%f\n",scale);
     
     }*/
    
    
}

//--------------------------------------------------------------
void ofApp::touchUp(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::touchDoubleTap(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::touchCancelled(ofTouchEventArgs & touch){
    
}

//--------------------------------------------------------------
void ofApp::lostFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotFocus(){
    
}

//--------------------------------------------------------------
void ofApp::gotMemoryWarning(){
    
}

//--------------------------------------------------------------
void ofApp::deviceOrientationChanged(int newOrientation){
    
}


