#pragma once

#include "ofMain.h"
#include "ofxiOS.h"
#include "ofxiOSExtras.h"
#define numberofpaintings 16


class ofApp : public ofxiOSApp{
    
public:
    void setup();
    void update();
    void draw();
    void exit();
    
    void touchDown(ofTouchEventArgs & touch);
    void touchMoved(ofTouchEventArgs & touch);
    void touchUp(ofTouchEventArgs & touch);
    void touchDoubleTap(ofTouchEventArgs & touch);
    void touchCancelled(ofTouchEventArgs & touch);
    
    void lostFocus();
    void gotFocus();
    void gotMemoryWarning();
    void deviceOrientationChanged(int newOrientation);
    
    ofVideoGrabber grabber;
    ofTexture tex;
    int buttonX;
    int buttonY;
    int buttonSize;
    int eyebuttonSize;
    int mapbuttonSize;
    int mapsize;
    int Pnumbers;
    Boolean isPressed;
    bool photoSavedToLibrary;
    bool loadpainting1;
    
    ofImage photo;
    ofImage frame;
    ofImage mapicon;
    ofImage cameraicon;
    ofImage zoomout;
    ofImage zoomin;
    ofImage img;
    ofImage worldmap;
    ofImage paintings[numberofpaintings];
    ofImage wmaps[numberofpaintings];
    //ofImage textbox[numberofpaintings];
    string stories[numberofpaintings];
    float scale[numberofpaintings];
    float posX[numberofpaintings];
    float posY[numberofpaintings];
    float zoomposX[numberofpaintings];
    float zoomposY[numberofpaintings];
    float distX;
    float distY;
    //float posX, posY, distX, distY, width, height;
    
    unsigned char *imgPixels;
    ofTrueTypeFont font;
    
    
    
    
    
    unsigned char* photoPixels;
    
    //three sections
    string view;
    
    
    
    
};
